=== debian/changelog ===
lapack (3.9.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 21 Mar 2020 13:27:50 +0100

lapack (3.9.0-1) unstable; urgency=medium

  [ Sébastien Villemot ]
  * d/watch: update for move to Github
  * New upstream version 3.9.0
  * lapacke-makefile.patch: drop patch, applied upstream
  * d/rules: adapt for renaming of variables and path changes in upstream
    Makefiles
  * liblapack-doc: remove unused override for spelling-error-in-manpage
  * missing-lapacke-prototypes.patch: new patch, fixes unresolved symbols in
    liblapacke
  * Adapt lapack autopkgtests for a behaviour change in lapack_testing.py

  [ Matthias Klose ]
  * Don't run the 64bit autopkg tests on 32bit architectures.
    (Closes: #944468)

  [ Mo Zhou ]
  * Also exclude the rest 32bit Arches (that doko missed) for autopkgtest.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 23 Nov 2019 11:25:11 +0100

lapack (3.8.0-8) unstable; urgency=medium

  [ Sébastien Villemot ]
  * Migrate to Python 3
    + python3.patch: new patch
    + d/control, d/tests/control: replace python by python3 (Closes: #943142)
  * Bump to debhelper compat level 12. (On mipsel, disable dh_dwz.)

  [ Mo Zhou ]
  * Fix FTBFS with doxygen 1.8.16 (Closes: #943431)
  * Add README.if-you-look-for-libcblas.so.3 to libblas-dev (Closes: #943715)

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 31 Oct 2019 20:43:00 +0800

lapack (3.8.0-7) unstable; urgency=medium

  * Revert debhelper compat level from 12 to 11, avoiding mipsel FTBFS.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 04 Oct 2019 09:32:15 +0000

lapack (3.8.0-6) unstable; urgency=medium

  * Bump S-V to 4.4.1
  * Bump to debhelper compat level 12

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 30 Sep 2019 14:23:13 +0200

lapack (3.8.0-5) experimental; urgency=medium

  [ Mo Zhou ]
  * Fixup {blas,lapack,tmglib}64-dev installation path.

  [ Sébastien Villemot ]
  * No longer compile the static 32-bit indexing libraries with -fPIC.
    Previously the static 32-bit indexing libraries were compiled with -fPIC,
    because the objects produced when building the shared libraries were not
    correctly deleted (the “make cleanlib” rule did not clean them, we now use
    “make clean” instead).
  * For 64-bit indexing, also recompile functions under INSTALL/*
    These functions were previously not recompiled, i.e. they were using 32-bit
    integers. This would lead to some weird problems, especially on big-endian
    archs.
  * For 64-bit indexing, fix the NOOPT compilation flags.
    Files compiled with NOOPT were not passed the -fdefault-integer-8 flag,
    leading to crashes and infinite loops.
  * libblas64-dev.prerm.in: fix path in alternative
  * liblapacke-dev: add missing Breaks+Replaces liblapacke (<< 3.8.0-3)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 26 Sep 2019 19:37:30 +0200

lapack (3.8.0-4) experimental; urgency=medium

  * Add header for patch makefile-blas-remove-dep.patch
  * Add a [Note] about CBLAS64 in changelog entry of (= 3.8.0-3).
  * Patch makefile to make the tests verbose (avoid timeout on buildd).

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 13 Sep 2019 05:58:09 +0000

lapack (3.8.0-3) experimental; urgency=medium

  [ Sébastien Villemot ]
  * Drop transitional package liblapack-doc-man
  * Remove -n flag in call to dh_makeshlibs. (Closes: #933353)

  [ Mo Zhou ]
  * Add myself to Uploaders.
  * Add "rename" to B-D to aid the build process.
  * control: Add packages for 64bit-indexing variants.
  * rules: Build the 64bit-indexing variant.
  * shlibs.local: Update dependency template for the 64bit-indexing variant.
  * Update installation control files.
  * Remove .install file for liblapack-pic due to merger into liblapack-dev.
  * Add postinst and prerm scripts for the 64bit-indexing variant.
  * Bump to Standards-Version 4.4.0
  * Fix alternative priority of liblapacke-dev (now 10 like other packages)
  * .pc file moved from liblapacke to liblapacke-dev
  * Don't build BLAS64/LAPACK64 on 32bit Architectures.
  * [Note] CBLAS64 is still not available in libblas64.so

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 22 Aug 2019 10:39:25 +0800
